---
title: NamedNodeMap
slug: Web/API/NamedNodeMap
tags:
  - API
  - DOM
  - Interface
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>NamedNodeMap</strong></code> interface represents a collection of {{domxref("Attr")}} objects. Objects inside a <code>NamedNodeMap</code> are not in any particular order, unlike {{domxref("NodeList")}}, although they may be accessed by an index as in an array.</p>

<p>A <code>NamedNodeMap</code> object is <em>live</em> and will thus be auto-updated if changes are made to its contents internally or elsewhere.</p>

<div class="note">
<p>Although called <code>NamedNodeMap</code>, this interface doesn't deal with {{domxref("Node")}} objects but with {{domxref("Attr")}} objects, which were originally a specialized class of {{domxref("Node")}}, and still are in some implementations.</p>
</div>

<h2 id="Properties">Properties</h2>

<p><em>This interface doesn't inherit any property.</em></p>

<dl>
 <dt>{{domxref("NamedNodeMap.length")}} {{ReadOnlyInline}}</dt>
 <dd>Returns the amount of objects in the map.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface doesn't inherit any method.</em></p>

<dl>
 <dt>{{domxref("NamedNodeMap.getNamedItem()")}}</dt>
 <dd>Returns a {{domxref("Attr")}}, corresponding to the given name.</dd>
 <dt>{{domxref("NamedNodeMap.setNamedItem()")}}</dt>
 <dd>Replaces, or adds, the {{domxref("Attr")}} identified in the map by the given name.</dd>
 <dt>{{domxref("NamedNodeMap.removeNamedItem()")}}</dt>
 <dd>Removes the {{domxref("Attr")}} identified by the given map.</dd>
 <dt>{{domxref("NamedNodeMap.item()")}}</dt>
 <dd>Returns the {{domxref("Attr")}} at the given index, or <code>null</code> if the index is higher or equal to the number of nodes.</dd>
 <dt>{{domxref("NamedNodeMap.getNamedItemNS()")}}</dt>
 <dd>Returns a {{domxref("Attr")}} identified by a namespace and related local name.</dd>
 <dt>{{domxref("NamedNodeMap.setNamedItemNS()")}}</dt>
 <dd>Replaces, or adds, the {{domxref("Attr")}} identified in the map by the given namespace and related local name.</dd>
 <dt>{{domxref("NamedNodeMap.removeNamedItemNS()")}}</dt>
 <dd>Removes the {{domxref("Attr")}} identified by the given namespace and related local name.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#interface-namednodemap', 'NamedNodeMap')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Deals with {{domxref("Attr")}} instead of {{domxref("Node")}}</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM3 Core', 'core.html#ID-1780488922', 'NamedNodeMap')}}</td>
   <td>{{Spec2('DOM3 Core')}}</td>
   <td>No change from {{SpecName('DOM2 Core')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Core', 'core.html#ID-1780488922', 'NamedNodeMap')}}</td>
   <td>{{Spec2('DOM2 Core')}}</td>
   <td>Added <code>getNamedItemNS()</code>, <code>setNamedItemNS()</code> and <code>removeNamedItemNS()</code></td>
  </tr>
  <tr>
   <td>{{SpecName('DOM1', 'core.html#ID-1780488922', 'NamedNodeMap')}}</td>
   <td>{{Spec2('DOM1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.NamedNodeMap")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Element.attributes")}}</li>
</ul>
